=== debian/changelog ===
cmake (3.6.2-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 05 Nov 2016 00:25:34 +0100

cmake (3.6.2-2) unstable; urgency=medium

  * Add mips-rld-map-rel.patch to solve segfaults caused by new
    DT_MIPS_RLD_MAP_REL tag and RPATH removers (Closes: #820334).
    Thanks James Cowgill for the patch.
  * Refresh patches.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Fri, 14 Oct 2016 22:29:17 -0300

cmake (3.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Fix broken binaries when using clang with -fsanitize. (Closes: #835426)
    - Add CMakeParseImplicitLinkInfo_Exclude_libclang_rt.patch,
      cherry-picked from upstream.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 11 Sep 2016 18:25:36 +0200
