=== debian/tests/control ===
Tests: testsuite testsuite-ninja findmodules
Restrictions: allow-stderr
Depends: cmake,
  ninja-build,
  @builddeps@,
  libasound2-dev,
  libarmadillo-dev,
  bison,
  libboost-dev,
  libbz2-dev,
  libcups2-dev,
  libcurl4-openssl-dev,
  cvs,
  doxygen,
  libexpat1-dev,
  flex,
  libfreetype6-dev,
  gettext,
  libgif-dev,
  git,
  imagemagick,
  libmagickcore-dev,
  libmagick++-dev,
  libmagickwand-dev,
  libgnutls28-dev,
  libgtk2.0-dev,
  mercurial,
  hspell,
  icoutils,
  libjasper-dev,
  libarchive-dev,
  liblzma-dev,
  libxml2-dev,
  libxslt1-dev,
  libopenscenegraph-dev,
  perl,
  libphysfs-dev,
  pkg-config,
  ruby-dev,
  libprotobuf-dev,
  protobuf-compiler,
  subversion,
  swig,
  libtiff5-dev,
  zlib1g-dev
